<?php
/*---------------------------------------------------+
| PHP-Fusion 7 Content Management System
+----------------------------------------------------+
| Copyright  2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
|----------------------------------------------------+
| Infusion: Dynamic Menu
| Filename: dm_admin.php
| Author: Norman.Leonardi
| Web: http://www.ny-soft.com/
+----------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+----------------------------------------------------*/


if(file_exists("../../maincore.php")){
	require_once "../../maincore.php";
}else{
	require_once "../../../maincore.php";
}
require_once INFUSIONS."dynamic_menu/functions.php";

error_reporting(E_ALL ^ E_NOTICE);

//init variable////////////////////////////////////////
$mode = isset($_POST['mode']) ? $_POST['mode'] : "";
$func = isset($_POST['func']) ? $_POST['func'] : "";
$link_id = isset($_POST['link_id']) ? $_POST['link_id'] : "";
$parent_id = isset($_POST['parent_id']) ? $_POST['parent_id'] : "";
$order = isset($_POST['order']) ? $_POST['order'] : "";
//init variable////////////////////////////////////////

function check_validity($link_id,$parent_id){
	global $locale;

	if( $link_id=="" ||  $parent_id==""){
		return $locale['e_blank'];
	}else{
		return "OK";
	}
}

function sync_menu(){
	
	$sql="	INSERT INTO ".DB_DM."(link_id,parent_id)
			SELECT 
				link_id,
				'0' as parent_id 
			FROM ".DB_PREFIX."site_links
			WHERE
				link_id NOT IN (SELECT link_id FROM ".DB_DM.")
		";
	$rs=dbquery($sql);
	
	$sql="	DELETE FROM ".DB_DM."
			WHERE
				link_id NOT IN (SELECT link_id FROM ".DB_PREFIX."site_links)
		";
	$rs=dbquery($sql);
	
	$sql="	UPDATE ".DB_DM."
			SET
				parent_id='0'
			WHERE
				parent_id NOT IN (SELECT link_id FROM ".DB_PREFIX."site_links)
		";
	$rs=dbquery($sql);
	
}

function list_link(){
	global $locale;
	
	$tmp='';
	$tmp=$tmp.'<select id="link" name="link">';
	$tmp=$tmp.'<option value="">'.iconv("Windows-1251", "UTF-8", $locale['choose']).'</option>';
	$sql="SELECT link_id,link_name FROM ".DB_PREFIX."site_links ORDER BY link_order";
	$rs=dbquery($sql);
	while($row=dbarray($rs)){
		$tmp=$tmp.'<option value="'.$row['link_id'].'">'.iconv("Windows-1251", "UTF-8", $row['link_name']).'</option>';
	}
	$tmp=$tmp.'</select>';
	
	return $tmp;
}

function list_parent(){
	
	$tmp='';
	$tmp=$tmp.'<select id="parent" name="parent">';
	$tmp=$tmp.'<option value="0">Root</option>';
	
	unset($parent);
	unset($parentName);
	$sql="
			SELECT 
				a.link_id,
				a.link_name,
				b.parent_id 
			FROM ".DB_PREFIX."site_links a
			LEFT JOIN ".DB_DM." b ON a.link_id=b.link_id
			WHERE b.parent_id='0'
	     	ORDER BY a.link_order
		 ";
	$rs=dbquery($sql);
	$i=0;
	while($row=dbarray($rs)){
		$parent[$i]=$row['link_id'];
		$parentName[$i]=$row['link_name'];
		$i++;
	}
	
	$max=count($parent);
	$depth='--';
	for($i=0;$i<$max;$i++){
		$tmp=$tmp.'<option value="'.$parent[$i].'">'.iconv("Windows-1251", "UTF-8", $parentName[$i]).'</option>';
		$tmp=$tmp.search_child2($parent[$i],$depth);
	}
	
	return $tmp;
}


function display_menu(){
	$tmp='';
	unset($parent);
	unset($parentName);
	unset($order);
	
	$sql="
			SELECT 
				a.link_id,
				a.link_name,
				b.parent_id,
				a.link_order
			FROM ".DB_PREFIX."site_links a
			LEFT JOIN ".DB_DM." b ON a.link_id=b.link_id
			WHERE b.parent_id='0'
	     	ORDER BY a.link_order
		 ";
	$rs=dbquery($sql);
	$i=0;
	while($row=dbarray($rs)){
		$parent[$i]=$row['link_id'];
		$parentName[$i]=$row['link_name'];
		$order[$i]='<input style="text-align:center;" name="order_'.$row['link_id'].'" id="order_'.$row['link_id'].'" type="text" value="'.$row['link_order'].'" size="2" />&nbsp;';
		$i++;
	}
	
	$max=count($parent);
	$depth='--';
	for($i=0;$i<$max;$i++){
		$tmp=$tmp.'<div>'.$order[$i].iconv("Windows-1251", "UTF-8", $parentName[$i]).'';
		$tmp=$tmp.search_child($parent[$i],$depth);
		$tmp=$tmp.'</div>';
	}
	
	return $tmp;
}

function search_child($parent,$depth){
	$tmp='';
	
	$sql="
			SELECT 
				a.link_id,
				a.link_name,
				b.parent_id,
				a.link_order
			FROM ".DB_PREFIX."site_links a
			LEFT JOIN ".DB_DM." b ON a.link_id=b.link_id
			WHERE b.parent_id='".$parent."'
	     	ORDER BY a.link_order
		 ";
	$rs=dbquery($sql);
	while($row=dbarray($rs)){
		$order='<input style="text-align:center;"  name="order_'.$row['link_id'].'" id="order_'.$row['link_id'].'" type="text" value="'.$row['link_order'].'" size="2" />&nbsp;';
		$tmp=$tmp.'<div>'.$order.$depth.iconv("Windows-1251", "UTF-8", $row['link_name']).'';
		$depth=$depth.'--';
		$tmp=$tmp.search_child($row['link_id'],$depth);
		$tmp=$tmp.'</div>';
		$depth=substr($depth,0,strlen($depth)-2);
	}
	
	return $tmp;
}

function search_child2($parent,$depth){
	$tmp='';
	$sql="
			SELECT 
				a.link_id,
				a.link_name,
				b.parent_id 
			FROM ".DB_PREFIX."site_links a
			LEFT JOIN ".DB_DM." b ON a.link_id=b.link_id
			WHERE b.parent_id='".$parent."'
	     	ORDER BY a.link_order
		 ";
	$rs=dbquery($sql);
	while($row=dbarray($rs)){
		$tmp=$tmp.'<option value="'.$row['link_id'].'">'.$depth.iconv("Windows-1251", "UTF-8", $row['link_name']).'</option>';
		$depth=$depth.'--';
		$tmp=$tmp.search_child2($row['link_id'],$depth);
		$depth=substr($depth,0,strlen($depth)-2);
	}
	
	return $tmp;
}

function save($link_id,$parent_id){
	
	$cv=check_validity($link_id,$parent_id);
	
	if($cv!="OK"){
		return $cv;
	}else{	
		$sql="DELETE FROM ".DB_DM." WHERE link_id='".$link_id."'";
		$rs=dbquery($sql);
		
		$sql="	INSERT INTO ".DB_DM."(link_id,parent_id)
				SELECT
					'".$link_id."' as link_id,
					'".$parent_id."' as parent_id
			 ";
		$rs=dbquery($sql);
		
		return 'OK!';
	}
}

function save_order($order){

	$arr=explode(",",$order);
	$max=count($arr);
	for($i=0;$i<$max;$i++){
		$id=explode(":",$arr[$i]);
		$sql="	UPDATE ".DB_PREFIX."site_links 
				SET
					link_order='".$id[1]."'
				WHERE link_id='".$id[0]."'";
		$rs=dbquery($sql);
	}
	
	return 'OK!';	
}

function create_js(){
	$sql="SELECT link_id,link_order FROM ".DB_PREFIX."site_links";
	$rs=dbquery($sql);
	while($row=dbarray($rs)){
		$tmp=$tmp.''.$row['link_id'].':"+document.getElementById("order_'.$row['link_id'].'").value+",';
	}
	
	$tmp='order="'.substr($tmp,0,strlen($tmp)-1).'";';
	
	return $tmp;
}

if($mode=="AJAX"){
	if($userdata['user_id']!=""){
		if($func=="display_menu"){
			echo display_menu();
		}elseif($func=="list_link"){
			echo list_link();
		}elseif($func=="list_parent"){
			echo list_parent();
		}elseif($func=="sync_menu"){
			echo sync_menu();
		}elseif($func=="save"){
			echo save($link_id,$parent_id);
		}elseif($func=="save_order"){
			echo save_order($order);
		}
	}else{
		echo "Session Expired!";
	}
	exit;
}
?>
